use strict;
package SuikaWiki::Plugin::Registry;


our %Info;
$Info{q#Menu#}->{Name} = q#Menu#;
$Info{q#Menu#}->{q#Version#} = q#2004.1205.0529#;
$Info{q#Menu#}->{q#InterfaceVersion#} = q#2.9.1#;
$Info{q#Menu#}->{q#mkpluginVersion#} = q#2.1.21#;
$Info{q#Menu#}->{q#module_name#} = q#SuikaWiki::Plugin::plugin::Menu1041105052955PjN_#;
$Info{q#Menu#}->{q#Date.RCS#} = q#$Date: 2010/05/16 23:05:50 $#;
$Info{q#Menu#}->{RequiredPlugin} = [q#Error#, q#HTML#, q#WikiLinking#, q#WikiStruct#];
$Info{q#Menu#}->{Description} = [[q#Navigation menu bar#, q#en#, q##]];
$Info{q#Menu#}->{License} = [[q#%%Perl%%#, q##, q##]];
$Info{q#Menu#}->{Author} = [[[[q#Wakaba#, q#ja#, q#Latn#]], [[q#w@suika.fam.cx#]], [q##]]];

push @SuikaWiki::View::Implementation::CommonViewDefs, {
  condition => {q#mode#, q#mininav#, q#http_method#, [q#GET#, q#HEAD#]},
  object_class => q#SuikaWiki::Plugin::plugin::Menu1041105052955PjN_::mininav1041105052955Rcvu#,
};
package SuikaWiki::Plugin::plugin::Menu1041105052955PjN_::mininav1041105052955Rcvu;


our @ISA = q#SuikaWiki::View::template#;

sub main ($$$) {
  my ($self, $opt, $opt2) = @_;
  require SuikaWiki::Output::HTTP;
  $opt2->{output} = SuikaWiki::Output::HTTP->new
    (wiki => $self->{view}->{wiki},
     view => $self->{view}, viewobj => $self);
  for (@{$self->{view}->{wiki}->{var}->{client}->{used_for_negotiate}},
       'Accept-Language') {
    $opt2->{output}->add_negotiate_header_field ($_);
  }
  
  $opt2->{template} = q#%html-document (
title => {%res (name => {View:Mininav:WebPageTitle});}p,
link-meta => {%template (name => links);}p,
content => {
%section (type => body, content=>{
%block (
id => side-menu,
class => mininav,
content => {
%read (when-no-converter => 406);
%link-to-wikipage (
rel => view,
mode => mininav, up-to-date,
class => wiki-cmd,
label => {%link-to-it (
label => {%res (name=>ReloadThisPage);}p,
);},
description => {%res (name=>ReloadThisPageLong);}p,
);
}p,
);
%section (
title => {%res (name => {Error:Title});}p, heading,
content => {%error-list;}p,
);
}p);
}p,
);#;
  $opt2->{o} = bless {
                      ## SuikaWiki 3 WikiPlugin interface
                        wiki => $self->{view}->{wiki},
                        plugin => $self->{view}->{wiki}->{plugin},
                        var => {},
                      }, 'SuikaWiki::Plugin';  
  $opt2->{output}->{status_code} = 200;
  
  $opt2->{output}->{entity}->{media_type} = q#text/html#;

  $opt2->{output}->{entity}->{charset} = $self->{view}->{wiki}->{config}->{charset}->{output};
  $opt2->{output}->set_expires (%{$self->{view}->{wiki}->{config}->{entity}->{expires}->{q#view#}});
  $opt2->{output}->{entity}->{body_is_octet_stream} = 0;
  
  $self->{view}->{wiki}->init_db;
  $self->main_pre ($opt, $opt2);
  
  require Message::Markup::XML::Serialize::HTML;
  use Message::Util::Error;
  try {
    $opt2->{output}->{entity}->{body} 
      = Message::Markup::XML::Serialize::HTML::html_simple
        (SuikaWiki::Plugin->formatter ('view')
        ->replace ($opt2->{template}, param => $opt2->{o}));
  } $self->{view}->{wiki}->{config}->{catch}->{ formatter_view };
  $opt2->{output}->output (output => 'http-cgi');
  
  $self->main_post ($opt, $opt2);
}

push @{$SuikaWiki::View::Implementation::TemplateFragment{q#links#}},   {
    Main => q#%link-wiki (
page => {Wiki//MenuBar},
mode => mininav,
rel => {sidebar navigator},
); #,
    Order => 0,
    Description => [[q#Link to MenuBar WikiPage, with relationship of "sidebar", "navigation".#, q#en#, q##]],
  };

package SuikaWiki::Plugin::Resource;

our $BaseResource;
$BaseResource->{q#en#}->{q##}->{q#ReloadThisPage#} = q#Reload#;
$BaseResource->{q#en#}->{q##}->{q#ReloadThisPageLong#} = q#Reload this WikiPage#;
$BaseResource->{q#und#}->{q##}->{q#View:Mininav:WebPageTitle#} = q#%page-name;#;
package SuikaWiki::Plugin::Registry;

$Info{q#Menu#}->{provide} = {q#viewfragment#, [{q#Name#, q#links#}], q#viewdef#, [{q#Description#, [q#Mini navigation menu bar#, q#en#, q##], q#Name#, q#mininav#}]};

1;
